;***** BALLOON.LSP *****;

(defun errexit (s)
  (princ "\nError:  ")
  (princ s)
  (restore)
)

(defun bx ()
  (setvar "CMDECHO" (car oldvar))
  (setvar "BLIPMODE" (cadr oldvar))
  (setvar "OSMODE" (nth 2 oldvar))
  (setvar "CLAYER" (nth 3 oldvar))
  (setvar "DONUTID" (nth 4 oldvar))
  (setvar "DONUTOD" (nth 5 oldvar))
  (setq *error* olderr)
  (princ)
)

(defun C:BALLOON (/ tmp ts th nh ip sp ali le BLAYER LBLOCK TEXTGAP BWIDTH)
  
  (setq T (not nil))
  (setq olderr  *error*
        restore bx
        *error* errexit
  )
  (setq oldvar 
    (list 
      (getvar "CMDECHO") 
      (getvar "BLIPMODE") 
      (getvar "OSMODE")
      (getvar "CLAYER")
      (getvar "DONUTID")
      (getvar "DONUTOD")
    )
  )
  (setvar "CMDECHO" 0)
  (setvar "BLIPMODE" 0)
  (setvar "OSMODE" 0)
  (terpri)
;**************************************************************************
                           
                           ;Balloons are created as blocks
    (setq LBLOCK T)        ;  unless LBLOCK is set to nil here.
  
                           ;Layer For Balloon Placement:
    (setq BLAYER "dim")    ;   "XXXX" = Place on layer XXXX
                           ;   nil    = Use current layer

    (setq TEXTGAP 0.8)     ;Desired Gap Between Text & Balloon
                           ;   (1 unit = Dimension Text Height)

    (setq BWIDTH 0.04)     ;Balloon Line Width
                           ;   nil = no width
                           ;   (1 unit = Dimension Text Height)

;**************************************************************************
  (if 
    (= 0 
      (setq th 
        (cdr (assoc '40 (tblsearch "style" (getvar "textstyle"))))
      )
    ) 
    (setq nh (setq th (* (getvar "DIMTXT") (getvar "DIMSCALE"))))
    (setq nh nil)
  )
  (if BLAYER  
    (command "LAYER"
      (if (tblsearch "LAYER" BLAYER) "S" "M")
      BLAYER
      ""
    )
  )
  (setq le (entlast))
  (setq ip (setq sp (getpoint "Pick Leader Start Point: ")))
  (command "DIM1"
     "LEADER"
     sp
  )
  (while
    (setq sp 
      (progn 
        (initget "Undo") 
        (getpoint sp "\nNext point on leader line: ")
      )
    )
    (command sp)
    (setq sp (getvar "LASTPOINT"))
  )
  (command cancel)
  (setq sp (cdr (assoc '11 (entget (entlast)))))
  (setq ali (angle (cdr (assoc '10 (entget (entlast)))) sp))  
  (setq tmp (getstring T "Enter Balloon Text:  "))
  (setq ts (textbox (list (cons '1 tmp))))
  (setq ts 
    (list 
      (+ (- (car (cadr ts)) (car (car ts))) (* 2 TEXTGAP th))
      (* 3 TEXTGAP th)
    )
  )
  (command "TEXT"
           "M"
           (polar 
             sp 
             ali 
             (* 0.5 (if (<= (strlen tmp) 2) (cadr ts) (car ts))) 
           )
  )
  (if nh (command th))
  (command 
    (if (<= (strlen tmp) 2)
      '0
      (rtd
        (if 
          (and (< ali (* 3 (/ pi 2))) (> ali (/ pi 2))) 
          (+ ali pi) 
          ali
        )
      )
    )
    tmp
  )
  (if (<= (strlen tmp) 2)
    (command "DONUT" 
             (cadr ts) 
             (cadr ts) 
             (polar 
               sp 
               ali 
               (* 0.5 (if (<= (strlen tmp) 2) (cadr ts) (car ts))) 
             )
             ""
    )
    (command "ELLIPSE" 
             sp 
             (polar sp ali (if (<= (strlen tmp) 2) (cadr ts) (car ts)))
             (/ (cadr ts) 2)
    )
  )
  (if 
    (and BWIDTH (> BWIDTH 0)) 
    (command "PEDIT" (entlast) "W" (* th BWIDTH) "X")
  )
  (if LBLOCK
    (progn
      (entmake (list 
        (cons '0 "BLOCK") 
        (cons '2 "*U") 
        (cons '70 1) 
        (cons '10 ip)
      ))
      (while (and (setq th (entlast)) (not (eq th le)))
        (entmake (entget (setq tmp th)))
        (while (setq tmp (entnext tmp)) (entmake (entget tmp)))
        (entdel th)
      ) 
      (setq tmp (entmake (list (cons '0 "ENDBLK"))))
      (entmake (list 
        (cons '0 "INSERT") 
        (cons '2 tmp) 
        (cons '10 ip)
      ))
    )
  )   
  (restore)
)
